; 1-Wire Definitions Pin and Macro
#define W1_Page		movlb	0x0	; BSR  Bank-0 for 1-W  Task
#define	Timer0_Present	Yes	;      

#ifdef	__DEBUG
	#define Debug_1W	 	1 	;   5, , 1= 
#else
	#define Debug_1W	 	0 	;   5, , 1= 
#endif

#define MaxW1Pointer	d'45'	;   1-Wire

 #ifdef	PORTD	;4431
#define W1_TRIS			TRISC
#define W1_Lat			LATC
#define W1_Port			PORTC
#define W1_Pin			0	; 15  4431
 #else			;2431
#define W1_TRIS			TRISC
#define W1_Lat			LATC
#define W1_Port			PORTC
#define W1_Pin			7	; 18  2431
 #endif

#define W1_Clear		bcf	W1_Lat,W1_Pin,ACCESS
#define W1_Set			bsf	W1_Lat,W1_Pin,ACCESS
#define W1_Output		bcf	W1_TRIS,W1_Pin,ACCESS
#define W1_Input		bsf	W1_TRIS,W1_Pin,ACCESS

;     1-Wire:
;  - 1 ROM  - 1  Functional 

#define DS1820_SEARCHROM 		0xF0	; ROM  
#define DS1820_SKIP_ROM			0xCC	; ROM  
#define DS1820_READROM 			0x33	; ROM  
#define DS1820_MATCHROM 		0x55	; ROM  
;#define DS1820_ALARMSEARCH 	0xEC	; ROM  

;#define DS1820_WRITE_SCRATCHPAD 0x4E; Functional 
#define DS1820_READ_SCRATCHPAD	0xBE ; Functional 
;#define DS1820_COPY_SCRATCHPAD 0x48 ; Functional 
;#define DS1820_READ_EEPROM 	0xB8 ; Functional 
;#define DS1820_READ_PWRSUPPLY 	0xB4 ; Functional 
#define DS1820_CONVERT_T		0x44 ; Functional 
;#define DS1820_FAMILY_CODE_DS18B20      0x28
;#define DS1820_FAMILY_CODE_DS18S20      0x10

