;******************************************************************************
;    Filename: RTOS_Math.asm                                               *
;    Date:  27/03/2017                                                                   *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
;       
;       .
;          
;     .
;     - .
;    -    
;         .
	#include Define.h	;    
;*******************************
;    -   
 #ifdef	Math_Present
;*******************************
		Extern	InitAll
	;global	A_Arg,B_Arg,RPM_Test
Math	code
		;      NOP
	goto	InitAll			;       - 
;RecipTable;   0x10002/0xHH 16/8U
;#include Proj_Dir\Math\Reciprocal.inc	
;*******************************************
Math_Steps	;	   ""
	movf Math_Step,W,BANKED;	 ""
	sublw	d'45'	; Sub WREG from Literal
	btfss	_C	;    
		goto	Math_EndCmd	;  ,  .

#ifdef	CompGoToTest
		Extern	CaseBra
 movf Math_Step,W,BANKED;	 ""
 call	CaseBra	;   WREG -     -  
;    2   BRA  RETLW
 #else
	BraReg	Math_Step,BANKED;	  "" 
 #endif

; BRA   :
 #include Proj_Dir\Math\Math_Task.inc	
 global	Math_Task	;
Math_Task	;	
 Math_Page	; BSR for Math Task
	btfsc	Math_Flag,1,ACCESS	;     ?
		bra	Math_Steps	;	   ""
	bsf		Math_Flag,1,ACCESS	;   
;     - 8 ,   10-12
	movf Math_Cmd,W,ACCESS	;    - 
 bz		Math_Cmd0 ; 
	dcfsnz	WREG,W,ACCESS	
 bra	Math_Cmd1 ; 
	dcfsnz	WREG,W,ACCESS	
 bra	Math_Cmd2 ; 
	dcfsnz	WREG,W,ACCESS	
 bra	Math_Cmd3 ; 
Math_Cmd4 ;
	bcf		Math_Flag,1,ACCESS	;   
 bcf	Math_Flag,0,ACCESS	;   
	return	;
Math_Cmd0 ;   -  .
; 24   60*12 000000/256 = 2 812 500
;    16     RevCalc_Flag;,F,BANKED;-1,
;      
;	clrf	Math_Step,BANKED;	   - DIV_3216 
	movlf	d'44',Math_Step,BANKED;	  
;	

;	movlf	d'45', FXD2424U_Return,BANKED	;     
 #ifdef __DEBUG
	clrf	B_Arg+3,BANKED	;	
	clrf	B_Arg+2,BANKED	;
	movlf	0x38,B_Arg+1,BANKED;B_Arg+0	;  1  -    
	movlf	0x27,B_Arg+0,BANKED;B_Arg+1	;  2  -   
; 0x2AEA54/0x3827=0xC3
 #else
	
;	movff_N	TMR5_RevTime+1,B_Arg+0,2;B_Arg+0	;  1  -    
;	movff	TMR5_RevTime+1,B_Arg+1;B_Arg+1	;  2  -   
;	ovff	TMR5_RevTime+2,B_Arg+2;B_Arg+1	;  2  -   
	clrf	B_Arg+3,BANKED	;	
 #endif
;60*12/0xFFFF=2AEA
	;clrf	EXT_H,BANKED	;
	movlf	0x00,A_Arg+3,BANKED;A_Arg+2		;      	
	movlf	0x2A,A_Arg+2,BANKED;A_Arg+0		;      
	movlf	0xEA,A_Arg+1,BANKED;A_Arg+1		; Middle     
	movlf	0x54,A_Arg+0,BANKED;A_Arg+2		;      
	
		return	;        
	bra	Math_EndCmd	; 
Math_Cmd1 ; 
	bcf		Math_Flag,1,ACCESS	;   
Math_Cmd2 ; 
	bcf		Math_Flag,1,ACCESS	;   
Math_Cmd3 ; 
Math_EndCmd	; 
	bcf		Math_Flag,1,ACCESS	;   
 bcf	Math_Flag,0,ACCESS	;   
 clrf	Math_Cmd,ACCESS		;
 clrf	Math_Step,BANKED	;
	return	;

;*******************************
;    -   
 #endif	; #ifdef	Math_Present
;*******************************

; #ifdef ADC_Present
; #endif
;

;End of program
		END

