;******************************************
;    Filename: PCPWM_3F_4431.asm           *
;    Date:                                *
;    File Version: 000.001                *
;    Author: PSW.RU                       *
;    Company: Labs                        *
	#include Define.h	;     
;*******************************
;    -   
;*******************************
 #ifdef	PCPWM_Present

	global	PCPWM_Task, SpeedCalc,SpeedChange,StopMotor,MotorFault
	global	RevCalc,DelayCuriosity ;   .
	global	PDC_TableLoad;,DelayCuriosity ;   .

	Extern	InitAll,TabPwmFreq,TabDeltAngle,Table_Sinus,Tab_SinEnd		;
	Extern	Table_Simples,Simples_100,Simples_200,Simples_400,Simples_800
	Extern	Restore_ML


;******************************************
PCPWM	code
;       - 
	movlw	0x21	;    
 call	Restore_ML	;        
	
SpeedCalc	;     100 
; rcall	PDC_TableLoad		;   
 #include Proj_Dir\PCPWM_3F\SpeedCalc.inc	;  -   

;SpeedChange	;   /   / PCPWM 
 #include Proj_Dir\PCPWM_3F\SpeedChange.inc	;  -   
	retlw	0x15	;  -    

RevCalc	;
 #include Proj_Dir\PCPWM_3F\Rev_Calc.inc	;  -   
 #include Proj_Dir\PCPWM_3F\SinTableLoad.inc	;     

PDC_TableLoad	;	   
 	bsf PCPWM_Flag2,0,ACCESS;;0=     
 #include Proj_Dir\PCPWM_3F\PDC_TableLoad.inc;    
	return

Angle_TableLoad	;
	bsf	PCPWM_Flag2,1,ACCESS;1=       
 #include Proj_Dir\PCPWM_3F\Angle_TableLoad.inc;     
	return

PCPWM_Task	;  PCPWM 11.7/23.4/18.75 	
;*******************************************
		PCPWM_Page	; BSR for PCPWM Task
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory

	btfss	PCPWM_Flag2,0,ACCESS;;0=     
		rcall	PDC_TableLoad	;      
	btfss	PCPWM_Flag2,1,ACCESS;1=       
		rcall	Angle_TableLoad	;      
	
; #include Proj_Dir\PCPWM_3F\PDC_TableLoad.inc;    


 #ifdef	PCPWM_1PhCalc	;;    -  1   .
	dcfsnz	SynFaza,F,BANKED	; 
	 bra		Faza_1 ; -1
	movf	SynFaza,W,BANKED	; 
	dcfsnz	WREG,W,ACCESS		;  
	 bra		Faza_2 ; -2
	dcfsnz	WREG,W,ACCESS		;   
	 bra		Faza_3 ; -3
;    3    	
Faza_1 ; -1
	movlf	0x3,SynFaza,BANKED	;   
 #endif;#ifdef	PCPWM_1PhCalc	;;    -  1   . #else

; #ifdef PCPWM_Dbg12b	; Yes	;  12   
; 	SinTabLdDbg	 Angle_1+2,PDC0L	;      
; #else
	SinTableLoad Angle_1+2,PDC0L	;       
; #endif

 #ifdef	PCPWM_1PhCalc	;   
	return				;  -  1  
 #endif					;  .
Faza_2 ; -2

; Add24L3 Angle_2,BANKED,Angle_1,BANKED,0x555555	; D=B+A       +1/3 	
 Add24S3 Angle_2,BANKED,Angle_1,BANKED,PcPwmAngle_1,BANKED	; D=B+A       +1/3 	

; #ifdef PCPWM_Dbg12b ;	 Yes	;  12   
;	movlf	0x4,PDC1L,ACCESS	;   
;	movlf	0x4,PDC1H,ACCESS	; 
; #else
 SinTableLoad	Angle_2+2,PDC1L	;      
; #endif

 #ifdef	PCPWM_1PhCalc	;   
	return				;  -  1  
 #endif					;  .

Faza_3 ; -3

; Add24L3 Angle_3,BANKED,Angle_1,BANKED,0xAAAAAA	; D=B+A       +2/3 
 Add24S3 Angle_2,BANKED,Angle_1,BANKED,PcPwmAngle_2,BANKED	; D=B+A       +1/3 	
 SinTableLoad	Angle_2+2,PDC2L	;      

;********************		return	; ***********************

; call	DelayCuriosity	;	    
DelayCuriosity	;      ,
;  3   ,   8+4*index
;  0x15       ,
;  0x0F     .
	movf	DelayCuriosityIndex,W,ACCESS
DelayLoop;
	nop	;
	decfsz	WREG,W,ACCESS
		bra	DelayLoop;
	return	;

;
;;*******************************
;    -   
;*******************************
 #endif ;ifdef	PCPWM_Present
;End of program
		END
