@Echo Off
rem C:\Microchip\_Prg\RTOS_3F_4431\
C:
cd \Microchip\_Prg\RTOS_3F_4431

call :SubCopyBegin

rem      
rem    Main -   
call :SubRoute Main

rem     -   
rem         PWM - 
call :SubRoute EPROM

rem       - 
call :SubRoute Beeper

rem  -      -  
call :SubRoute Interrupt

rem  -  
call :SubRoute LCD_Key_Enc

rem 1-Ware   -  190125
call :SubRoute 1W

rem PCPWM      - 26/01/2019 
call :SubRoute PCPWM_3F

rem    -  ,   
call :SubRoute RTK

rem ADC          
call :SubRoute ADC

rem    - 
rem call :SubRoute Math

rem copy /a _Out\DefVarAcs_All.inc+_Out\DefVarEPROM_All.inc+Main\DefVarAcs_End.inc _Out\DefVarAcs_All.inc >nul
rem copy /a _Out\DefVarEPROM_All.inc+Main\DefVarEPROM_End.inc _Out\DefVarEPROM_All.inc >nul

copy /a _Out\DefVarAcs_All.inc+Main\DefVarAcs_End.inc _Out\DefVarAcs_All.inc >nul
copy /a _Out\DefVar0_All.inc+Main\DefVar0_End.inc _Out\DefVar0_All.inc >nul
copy /a _Out\DefVar1_All.inc+Main\DefVar1_End.inc _Out\DefVar1_All.inc >nul
copy /a _Out\DefVar2_All.inc+Main\DefVar2_End.inc _Out\DefVar2_All.inc >nul

goto EndCopyBatch

:SubCopyBegin

echo ; ********** GENERATED Common Define File Created %DATE% %TIME% >_Out\Define_All.inc
echo ; ********** GENERATED Common Init File Created %DATE% %TIME% >_Out\Init_All.inc
echo ; ********** GENERATED Common Main Loop Task File Created %DATE% %TIME% >_Out\MLTask_All.inc
echo ; ********** GENERATED Common Data Table File Created %DATE% %TIME% >_Out\Table_All.inc

rem CBLOCK   #INCLUDE   -  
rem  :

echo ; ********** GENERATED Common VarAcs File Created %DATE% %TIME% >_Out\DefVarAcs_All.inc
rem echo ; ********** GENERATED Common VarEPROM File Created %DATE% %TIME% >_Out\DefVarEPROM_All.inc
echo ; ********** GENERATED Common Var0 File Created %DATE% %TIME% >_Out\DefVar0_All.inc
echo ; ********** GENERATED Common Var1 File Created %DATE% %TIME% >_Out\DefVar1_All.inc
echo ; ********** GENERATED Common Var2 File Created %DATE% %TIME% >_Out\DefVar2_All.inc
set >_Out\Set.txt
goto EndCopyBatch


:SubRoute
if not exist %1\Define_%1.inc goto Next1
echo ; *******************  Begin File %1\Define_%1.inc ***************** >_Out\Temp.inc
copy /a _Out\Define_All.inc+_Out\Temp.inc+%1\Define_%1.inc _Out\Define_All.inc >nul
:Next1

if not exist %1\DefVar0_%1.inc goto Next2
echo ; *******************  Begin File %1\DefVar0_%1.inc **************** >_Out\Temp.inc
copy /a _Out\DefVar0_All.inc+_Out\Temp.inc+%1\DefVar0_%1.inc _Out\DefVar0_All.inc >nul
:Next2

if not exist %1\DefVar1_%1.inc goto Next3
echo ; *******************  Begin File %1\DefVar1_%1.inc **************** >_Out\Temp.inc
copy /a _Out\DefVar1_All.inc+_Out\Temp.inc+%1\DefVar1_%1.inc _Out\DefVar1_All.inc >nul
:Next3

if not exist %1\DefVar2_%1.inc goto Next4
echo ; *******************  Begin File %1\DefVar2_%1.inc **************** >_Out\Temp.inc
copy /a _Out\DefVar2_All.inc+_Out\Temp.inc+%1\DefVar2_%1.inc _Out\DefVar2_All.inc >nul
:Next4

if not exist %1\DefVarAcs_%1.inc goto Next5
echo ; *******************  Begin File %1\DefVarAcs_%1.inc **************** >_Out\Temp.inc
copy /a _Out\DefVarAcs_All.inc+_Out\Temp.inc+%1\DefVarAcs_%1.inc _Out\DefVarAcs_All.inc >nul
:Next5

if not exist %1\Table_%1.inc goto Next51
echo ; *******************  Begin File %1\Table_%1.inc **************** >_Out\Temp.inc
copy /a _Out\Table_All.inc+_Out\Temp.inc+%1\Table_%1.inc _Out\Table_All.inc >nul
:Next51


if not exist %1\Init_%1.inc goto Next6
echo ; *******************  Begin File %1\Init_%1.inc ***************** >_Out\Temp.inc
copy /a _Out\Init_All.inc+_Out\Temp.inc+%1\Init_%1.inc _Out\Init_All.inc >nul
:Next6

if not exist %1\MLTask_%1.inc goto Next7
echo ; *******************  Begin File %1\MLTask_%1.inc ***************** >_Out\Temp.inc
copy /a _Out\MLTask_All.inc+_Out\Temp.inc+%1\MLTask_%1.inc _Out\MLTask_All.inc >nul
:Next7


goto EndCopyBatch


:EndCopyBatch