;  Main.asm
; #include Proj_Dir\EPROM\EPROM_Data.inc	;    
;EEPROM_data code_pack 0xf00000 ;   
; Data to be programmed into the Data EEPROM is defined here

;        :
; 1.       Proj_Dir\1W\DefVar1_1W.inc
; 2.  /    Proj_Dir\EPROM\EPROM_RegsAdr.inc
; 3.      
;         Proj_Dir\EPROM\EPROM_RegsAdr.inc.
; 4.  ParametrNum   Proj_Dir\LCD_Key_Enc\Define_LCD_Key_Enc.inc
; 5.           
;   Proj_Dir\LCD_Key_Enc\LCD_Enc_Text.inc     
; 6.      , 
;Proj_Dir\LCD_Key_Enc\Task_Keys.inc~93  : movlw d'3';      "Accelerate"

#ifdef PCPWM_Board ;       
;    EPROM\EPROM_Data.inc
;  PCPWM_3F\Parameters_PSW_12b.xls/Param:N4:N35
  de 0x0F ;   0-15=PCPWM_MotorNum	+
  de 0x03 ;  =LCD_DebounceTimeOut
;	DE	d'53';0x22;09 LCD_6_4	;    4   6
  de d'53';0x53 ;  4 =LCD_6_4
  de 0x88 ;    =Adc_Corr+3
  de 0x45 ;  =Adc_Corr+2
  de 0x03 ;   =Adc_Corr+1
  de 0x04 ;  =Adc_Corr+0
  de 0x80 ;   (  )=Par_UV
  de 0xD4 ;  =Par_V
  de 0xE4 ; Par_VS; 10=  
  de 0xBD ;   =Par_T
	#ifdef	W1_Pin
  de 0x01 ; W1 Temp=Par_K
  de 0x22 ; W1 temp1=Par_K1
	#endif
  de 0x85 ;   DC =PcDC_VN
  de 0x1E ;~1.7    =PcPwmTopDT
  de 0x0C ; DTCON 0-63  =DTCON
  de 0x01 ; Delay Curiosity=DelayCuriosityIndex
;    
#else ;       - , , 
;    EPROM\EPROM_Data.inc
;  PCPWM_3F\Parameters_PSW_12b.xls/Param:N4:N35
  de 0x0E ;   0-15=PCPWM_MotorNum
  de 0x05 ;  =LCD_DebounceTimeOut
;	DE	d'53';0x22;09 LCD_6_4	;    4   6
  de d'53';0x53 ;  4 =LCD_6_4
  de 0x88 ;    =Adc_Corr+3
  de 0x45 ;  =Adc_Corr+2
  de 0x08 ;   =Adc_Corr+1
  de 0x09 ;  =Adc_Corr+0
;*****************************   
  de 0x10 ;   (  )=Par_UV
;***************************** 
  de 0xD4 ;  =Par_V
  de 0xE4 ; Par_VS; 10=  
  de 0x48 ;   =Par_T
	#ifdef	W1_Pin
  de 0x70 ; W1 Temp=Par_K
  de 0x65 ; W1 temp1=Par_K1
	#endif
  de 0x8A ;   DC =PcDC_VN
  de 0x0A ;     =PcPwmTopDT
  de 0x0C ; DTCON 0-63  =DTCON
  de 0x01 ; Delay Curiosity=DelayCuriosityIndex
;    
#endif

;    0   
  de 0x07 ;  =PCPWM_Speed
  de 0xbb ; V/F Amp=PCPWM_Amp
  de 0x46 ; V/F Start=PCPWM_VFStart
  de 0x27 ; Accelerate=PCPWM_Accelerate
  de 0x78 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x0A ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x75 ;   -127:127=PCPWM_AutoStart
  de 0x01 ;    =PcPwmProg
  de 0x10 ;  DC =PcDC_Kf
  de 0x20 ;    1=PCPWM_Speed_M0
  de 0x30 ;    2=PCPWM_Speed_M1
;;      :
;;	DE	d'00';0x10;10 PCPWM_MaxSpdIndx; 0=100  ,      .
;;	DE	0xBB;01 PCPWM_Amp
;;	DE	0x46;02 PCPWM_VFStart
;;	DE	0x1;07 DelayCuriosityIndex
;;	DE	0x27;03 PCPWM_Accelerate    .
;;   07 Over Current = 78 -     /  
;;        - .

;;;      400  2.2  220  :
;;	DE	d'03';0x10;10 PCPWM_MaxSpdIndx; 3=800  ,   400 .
;;	DE	0x93;01 PCPWM_Amp -  ,      18-24
;;	DE	0x06;02 PCPWM_VFStart -   -     .
;;	DE	0x1;07 DelayCuriosityIndex
;;	DE	0xFF;03 PCPWM_Accelerate    .
;;;   07 Over Current = F8;

;    1   
;     - 1.5  4  220/380  .
;  ~30 ,  ~ 3 .
  de 0xFF ;  =PCPWM_Speed
  de 0x80 ; V/F Amp=PCPWM_Amp
  de 0x54 ; V/F Start=PCPWM_VFStart
  de 0xFF ; Accelerate=PCPWM_Accelerate
  de 0x0E ; =Par_A
  de 0x04 ;   =PCPWM_MaxSpdIndx
  de 0x00 ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x00 ;   -127:127=PCPWM_AutoStart
  de 0x01 ;    =PcPwmProg
  de 0x01 ;  DC =PcDC_Kf
  de 0x80 ;    1=PCPWM_Speed_M0
  de 0x80 ;    2=PCPWM_Speed_M1

;;;   450  2.2  220  :
;;	DE	d'106';=450  PCPWM_MaxSpdIndx; 106.=0x6A=450  ,   225 .
;;	DE	0xB3;01 PCPWM_Amp -  ,      18-24
;;	DE	0x0A;02 PCPWM_VFStart -   -     .
;;	DE	0x1;07 DelayCuriosityIndex
;;	DE	0xFF;03 PCPWM_Accelerate    .
;;;   07 Over Current = 0x50; 

;    2   
  de 0x02 ;  =PCPWM_Speed
  de 0x02 ; V/F Amp=PCPWM_Amp
  de 0x02 ; V/F Start=PCPWM_VFStart
  de 0xF2 ; Accelerate=PCPWM_Accelerate
  de 0x52 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x05 ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x02 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x02 ;  DC =PcDC_Kf
  de 0x02 ;    1=PCPWM_Speed_M0
  de 0x02 ;    2=PCPWM_Speed_M1

;;;     1.5  4  220  ,      : 
;;	DE	0x10;=70 ; d'00';04 PCPWM_MaxSpdIndx; 0=100  ,      .
;;	DE	0xB0;05 PCPWM_Amp
;;	DE	0x27;06 PCPWM_VFStart
;;	DE	0x1;07 DelayCuriosityIndex
;;	DE	0x40;08 PCPWM_Accelerate    .
;;;    4  1.5  

;    3   
  de 0x03 ;  =PCPWM_Speed
  de 0x03 ; V/F Amp=PCPWM_Amp
  de 0x03 ; V/F Start=PCPWM_VFStart
  de 0xF3 ; Accelerate=PCPWM_Accelerate
  de 0x53 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x05 ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x03 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x03 ;  DC =PcDC_Kf
  de 0x03 ;    1=PCPWM_Speed_M0
  de 0x03 ;    2=PCPWM_Speed_M1

;;;     -1025 250  200  36  2   
;;	DE	d'106';=450 ; ;04 PCPWM_MaxSpdIndx; 0=100  ,      .
;;	DE	0xB0;05 PCPWM_Amp
;;	DE	0x27;06 PCPWM_VFStart
;;	DE	0x1;07 DelayCuriosityIndex
;;	DE	0xFF;08 PCPWM_Accelerate    .
;;;    4  1.5  

;    4   
  de 0x04 ;  =PCPWM_Speed
  de 0x04 ; V/F Amp=PCPWM_Amp
  de 0x04 ; V/F Start=PCPWM_VFStart
  de 0xF4 ; Accelerate=PCPWM_Accelerate
  de 0x54 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x04 ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x04 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x04 ;  DC =PcDC_Kf
  de 0x04 ;    1=PCPWM_Speed_M0
  de 0x04 ;    2=PCPWM_Speed_M1

;    5   
  de 0x05 ;  =PCPWM_Speed
  de 0x05 ; V/F Amp=PCPWM_Amp
  de 0x05 ; V/F Start=PCPWM_VFStart
  de 0xF5 ; Accelerate=PCPWM_Accelerate
  de 0x55 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x05 ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x05;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x05 ;  DC =PcDC_Kf
  de 0x05 ;    1=PCPWM_Speed_M0
  de 0x05 ;    2=PCPWM_Speed_M1

;    6   
  de 0x06 ;  =PCPWM_Speed
  de 0x06 ; V/F Amp=PCPWM_Amp
  de 0x06 ; V/F Start=PCPWM_VFStart
  de 0xF6 ; Accelerate=PCPWM_Accelerate
  de 0x56 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x06 ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x06 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x06 ;  DC =PcDC_Kf
  de 0x06 ;    1=PCPWM_Speed_M0
  de 0x06 ;    2=PCPWM_Speed_M1

;    7   
  de 0x07 ;  =PCPWM_Speed
  de 0x07 ; V/F Amp=PCPWM_Amp
  de 0x07 ; V/F Start=PCPWM_VFStart
  de 0xF7 ; Accelerate=PCPWM_Accelerate
  de 0x57 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x07 ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x07 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x07 ;  DC =PcDC_Kf
  de 0x07 ;    1=PCPWM_Speed_M0
  de 0x07 ;    2=PCPWM_Speed_M1

;    8   
  de 0x08 ;  =PCPWM_Speed
  de 0x08 ; V/F Amp=PCPWM_Amp
  de 0x08 ; V/F Start=PCPWM_VFStart
  de 0xF8 ; Accelerate=PCPWM_Accelerate
  de 0x58 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x08 ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x08 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x08 ;  DC =PcDC_Kf
  de 0x08 ;    1=PCPWM_Speed_M0
  de 0x08 ;    2=PCPWM_Speed_M1

;    9   
  de 0x09 ;  =PCPWM_Speed
  de 0x09 ; V/F Amp=PCPWM_Amp
  de 0x09 ; V/F Start=PCPWM_VFStart
  de 0xF9 ; Accelerate=PCPWM_Accelerate
  de 0x59 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x09 ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x09 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x09 ;  DC =PcDC_Kf
  de 0x09 ;    1=PCPWM_Speed_M0
  de 0x09 ;    2=PCPWM_Speed_M1

;    10   
  de 0x10 ;  =PCPWM_Speed
  de 0x10 ; V/F Amp=PCPWM_Amp
  de 0x10 ; V/F Start=PCPWM_VFStart
  de 0xE0 ; Accelerate=PCPWM_Accelerate
  de 0x60 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x0A ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x10 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x10 ;  DC =PcDC_Kf
  de 0x10 ;    1=PCPWM_Speed_M0
  de 0x10 ;    2=PCPWM_Speed_M1

;    11   
  de 0x11 ;  =PCPWM_Speed
  de 0x11 ; V/F Amp=PCPWM_Amp
  de 0x11 ; V/F Start=PCPWM_VFStart
  de 0xE1 ; Accelerate=PCPWM_Accelerate
  de 0x61 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x0B ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x11 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x11 ;  DC =PcDC_Kf
  de 0x11 ;    1=PCPWM_Speed_M0
  de 0x11 ;    2=PCPWM_Speed_M1

;    12   
  de 0x12 ;  =PCPWM_Speed
  de 0x12 ; V/F Amp=PCPWM_Amp
  de 0x12 ; V/F Start=PCPWM_VFStart
  de 0xE2 ; Accelerate=PCPWM_Accelerate
  de 0x62 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x0C ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x12 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x12 ;  DC =PcDC_Kf
  de 0x12 ;    1=PCPWM_Speed_M0
  de 0x12 ;    2=PCPWM_Speed_M1

;    13   
  de 0x13 ;  =PCPWM_Speed
  de 0x13 ; V/F Amp=PCPWM_Amp
  de 0x13 ; V/F Start=PCPWM_VFStart
  de 0xE3 ; Accelerate=PCPWM_Accelerate
  de 0x63 ; =Par_A
  de 0x00 ;   =PCPWM_MaxSpdIndx
  de 0x0D ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x13 ;   -127:127=PCPWM_AutoStart
  de 0x00 ;    =PcPwmProg
  de 0x13 ;  DC =PcDC_Kf
  de 0x13 ;    1=PCPWM_Speed_M0
  de 0x13 ;    2=PCPWM_Speed_M1

;   14  - -1025    0-30  
  de 0x63 ;  =PCPWM_Speed
  de 0x9D ; V/F Amp=PCPWM_Amp
  de 0x35 ; V/F Start=PCPWM_VFStart
  de 0xFF ; Accelerate=PCPWM_Accelerate
  de 0x2A ; =Par_A
  de 0x24 ;   =PCPWM_MaxSpdIndx
  de 0x09 ;   0-20=PcPwmFrqInd
  de 0x03 ;    0-3=PcPwmAngInd
  de 0x04 ;   -127:127=PCPWM_AutoStart
  de 0x01 ;    =PcPwmProg
  de 0x14 ;  DC =PcDC_Kf
  de 0x28 ;    1=PCPWM_Speed_M0
  de 0x14 ;    2=PCPWM_Speed_M1

;    15  __Debug
  de 0x01 ;  =PCPWM_Speed
  de 0xEE ; V/F Amp=PCPWM_Amp
  de 0xE6 ; V/F Start=PCPWM_VFStart
  de 0x33 ; Accelerate=PCPWM_Accelerate
  de 0x99 ; =Par_A
  de 0x04 ;   =PCPWM_MaxSpdIndx
  de 0x0A ;   0-20=PcPwmFrqInd
  de 0x01 ;    0-3=PcPwmAngInd
  de 0x77 ;   -127:127=PCPWM_AutoStart
  de 0x03 ;    =PcPwmProg
  de 0x99 ;  DC =PcDC_Kf
  de 0x88 ;    1=PCPWM_Speed_M0
  de 0x66 ;    2=PCPWM_Speed_M1

;;   12  
;	DE	d'20';=450 ; ;04 PCPWM_MaxSpdIndx; 0=100  ,      .
;	DE	0xFF;05 PCPWM_Amp
;	DE	0xFF;06 PCPWM_VFStart
;	DE	0x1;07 DelayCuriosityIndex
;	DE	0xFF;08 PCPWM_Accelerate    .
;;    12  

;;      -      
;  ,  /,    
;******************************************************************************
