; ********** GENERATED Common Main Loop Task File Created 16/12/2019 23:02:47.76 
; *******************  Begin File Main\MLTask_Main.inc ***************** 

;	*** main code goes here ***
;	movf	TMR1L,W,ACCESS	;	clrwdt

; #endif
 ; *******************  Begin File EPROM\MLTask_EPROM.inc ***************** 
;*********************   	  *******************************

 extern	EPROM_Sync
;	EPROM_Page; BSR for EPROM Task  EePROM_Sync
 #ifdef	LCD_Present
	btfsc	LCD_Flg1,0,ACCESS	;    ?
		call	EPROM_Sync	;  -     
 #endif
; *******************  Begin File Beeper\MLTask_Beeper.inc ***************** 
;		Beeper_Page	;
;	movlw	0x20
	
	;	dcfsnz	DeBug_Beeper,F,BANKED
	;	Beeper_Toggle	;
; *******************  Begin File LCD_Key_Enc\MLTask_LCD_Key_Enc.inc ***************** 
	extern	LCD_Task,Task_Keys,Task_KeyBoardInput,Encoder

;********************** LCD 44780  , ,   *******************
 ;LCD_BANK	;    	
 ;DefaultBankSelect
	;movlb	0x0					; BSR  1  LCD_Task
	btfss	LCD_Flg,4,ACCESS	;  LCD    ?
		call	LCD_Task	;  -    .
;************ Encoder Task **********************
 ;LCD_BANK	;    
	;DefaultBankSelect
	;movlb	0x0					; BSR  1  StepTask
	btfsc	TaskFlag1,1,ACCESS		;  PortB    PortB ?
		call	Task_Keys		;	  
 ;************           **********************
 ;LCD_BANK	;    
	;DefaultBankSelect
	;movlb	0x0					; BSR  1  StepTask
	btfsc	TaskFlag1,2,ACCESS		;  KeyRead    100  ?
		call	Task_KeyBoardInput		;	  

	btfsc	TaskFlag1,3,ACCESS		;  Encoder      ?
		call	Encoder		;	  

; *******************  Begin File 1W\MLTask_1W.inc ***************** 
;************* 1-Wire  *********************
  extern	W1_Task	;   	
;	W1_Page	; movlb	0x0					; BSR  0 
	btfsc	W_1_Flg,0,ACCESS		;  1-Wire   ?
		call	W1_Task		;	      
;	bra		DoneW1_Task		;   -    
; *******************  Begin File PCPWM_3F\MLTask_PCPWM_3F.inc ***************** 
;************ PCPWM_Task **********************
 Extern	PCPWM_Task,SpeedCalc,SpeedChange, StopMotor
 Extern	DelayCuriosity,RevCalc ;   
	;	PCPWM_Page	;
;      12 
;	btfsc	PCPWM_Flag,0,ACCESS	;  PCPWM  ?
;		call	PCPWM_Task ;   .
;      18750 
	btfss	PCPWM_Flag,1,ACCESS	; 1/100   ?
		bra	DoneSpeedCalc
	PCPWM_Page	; BSR for PCPWM Task
	bcf	PCPWM_Flag,1,ACCESS	;  ,    
		call	SpeedCalc ;   .
	;	dcfsnz	DeBug_Beeper,F,BANKED
	;	Beeper_Toggle	;
DoneSpeedCalc

;      9 375/XX 
	btfss	PCPWM_Flag,5,ACCESS	; 1/XX   ?
		bra	DoneSpeedChange

		PCPWM_Page	; BSR for PCPWM Task
	bcf PCPWM_Flag,5,ACCESS	;;5=     9 375  ,   
	movf	PcPwmProg,W,BANKED	;,F,BANKED;10=   
		bnz	PcPwmProg_0 ;  
; 0.    
	btfss	PCPWM_Flag,0,ACCESS;0=     LcdTask   
		bra	DoneKey
	bcf	PCPWM_Flag,0,ACCESS;0=     LcdTask   
;        
;#ifdef	PCPWM_Present
;	PCPWM_Page	; BSR for PCPWM Task
;******    	btfss	PortB_Buf,1,ACCESS	; /
	btfss	PortB_Buf,4,ACCESS	; / - 

		bsf	PCPWM_Flag1,1,ACCESS;1=   /
	btfss	PortB_Buf,1,ACCESS	; /
		bcf	PCPWM_Flag1,2,ACCESS;2=    /

#ifdef PCPWM_Board ;      
	btfss	PortB_Buf,2,ACCESS	; /
		bsf	PCPWM_Flag1,1,ACCESS;1=   /
	btfss	PortB_Buf,2,ACCESS	; /
		bsf	PCPWM_Flag1,2,ACCESS;2=    /
#else ;       - , , 
	btfss	PortB_Buf,4,ACCESS	; /
		bsf	PCPWM_Flag1,1,ACCESS;1=   /
	btfss	PortB_Buf,4,ACCESS	; /
		bsf	PCPWM_Flag1,2,ACCESS;2=    /
#endif	;#ifdef PCPWM_Board ;      

	btfsc	PortB_Buf,3,ACCESS		; /
		bra	DoneKey
#ifdef PCPWM_NoReverseKey; Yes	;  ""  
;  ""       " "
;        .
	btg	PCPWM_Flag1,6,ACCESS;   ;6=   ADC-0   
	movbi	PCPWM_Flag1,6,ACCESS,Debug_LED0
;	LED1_Toggle	;   
;	LED0_Toggle	;   
#else ;  
	movf	PCPWM_SpeedReal,W,BANKED;     .
	;btfss	PCPWM_Flag,3,ACCESS		; /
	bnz	SetFlagStpRevStart
;	btfsc	_Z		;   =0 ?
	btg	PCPWM_Flag,4,ACCESS		; / -   
	bra	DoneKey
SetFlagStpRevStart
	bsf	PCPWM_Flag1,4,ACCESS;4=  --  
#endif	;#ifdef PCPWM_NoReverseKey; Yes	;  ""  
DoneKey
;#endif	;#ifdef	PCPWM_Present
	call	SpeedChange ;  0 =  = 0.
	bra	SaveMotorStatus
PcPwmProg_0
	decfsz	WREG,W,ACCESS
		bra		PcPwmProg_1
;    -   GoTo   
;        
;  .
; *************************  1 ******************
 Extern	SpeedChange1
	btfss	PCPWM_Flag,0,ACCESS;0=     LcdTask   
		bra	DoneKey_1
	bcf	PCPWM_Flag,0,ACCESS;0=     LcdTask   
;        
	btfss	PortB_Buf,3,ACCESS	; / 
		bsf	PCPWM_Flag1,1,ACCESS;1=   /
	btfss	PortB_Buf,3,ACCESS	; /
		bcf	PCPWM_Flag1,2,ACCESS;2=    /

;#ifdef PCPWM_Board ;      
;	btfss	PortB_Buf,2,ACCESS	; /
;		bsf	PCPWM_Flag1,1,ACCESS;1=   /
;	btfss	PortB_Buf,2,ACCESS	; /
;		bsf	PCPWM_Flag1,2,ACCESS;2=    /
;#else ;       - , , 
	btfss	PortB_Buf,4,ACCESS	; /
		bsf	PCPWM_Flag1,1,ACCESS;1=   /
	btfss	PortB_Buf,4,ACCESS	; /
		bsf	PCPWM_Flag1,2,ACCESS;2=    /
;#endif	;#ifdef PCPWM_Board ;      

;	btfsc	PortB_Buf,3,ACCESS		; /
;		bra	DoneKey
;#ifdef PCPWM_NoReverseKey; Yes	;  ""  
;  ""       " "
;        .
;	btg	PCPWM_Flag1,6,ACCESS;   ;6=   ADC-0   
;	movbi	PCPWM_Flag1,6,ACCESS,Debug_LED0
;	LED1_Toggle	;   
;	LED0_Toggle	;   
;#else ;  
;	movf	PCPWM_SpeedReal,W,BANKED;     .
;	;btfss	PCPWM_Flag,3,ACCESS		; /
;	bnz	SetFlagStpRevStart
;;	btfsc	_Z		;   =0 ?
;	btg	PCPWM_Flag,4,ACCESS		; / -   
;	bra	DoneKey
;SetFlagStpRevStart
;	bsf	PCPWM_Flag1,4,ACCESS;4=  --  
;#endif	;#ifdef PCPWM_NoReverseKey; Yes	;  ""  
DoneKey_1
;#endif	;#ifdef	PCPWM_Present

	call	SpeedChange1 ; 1 =  = 1 .


	bra	SaveMotorStatus
PcPwmProg_1
	call	SpeedChange1 ; >1  = 1 .
SaveMotorStatus
	movwf	PCPWM_MotorStatus,BANKED ;
;	bra	DoneSpeedChange
DoneSpeedChange

	btfss	PCPWM_Flag,7,ACCESS	;   ?
		bra	DoneRevCalc
	PCPWM_Page	; BSR for PCPWM Task
		call	RevCalc ;   .

DoneRevCalc
	;	dcfsnz	DeBug_Beeper,F,BANKED
	;	Beeper_Toggle	;
; call	DelayCuriosity	;	   
; *******************  Begin File RTK\MLTask_RTK.inc ***************** 
 extern	TK_10,TK_100,TK_1000;    

;		ADC_Page	; BSR for ADC Task
;	Inc24	ADC_Cnt_All,BANKED	;  

;************ Time keeping **********************
;         - 
;    1000,100  10     
;   -    
;     100  1000  (18750       100  1000)
;  10      -    (   ).
	btfss	TaskFlag1,6,ACCESS		;  1000      ?
		bra	DoneTK_1000
	bcf	TaskFlag1,6,ACCESS		;  1000   
		RTK_Page	;
	call	TK_1000		;	   1000 
;	movwf	StatusRTK_1000
DoneTK_1000

	btfss	TaskFlag1,5,ACCESS		;  100      ?
		bra	DoneTK_100
	bcf	TaskFlag1,5,ACCESS		;  100  
		RTK_Page	;
	call	TK_100		;	   100 
;	movwf	StatusRTK_100
DoneTK_100

	btfss	TaskFlag1,0,ACCESS		;  10      ?
		bra	DoneTK_10
		RTK_Page	;
	bcf	TaskFlag1,0,ACCESS		;  10      ?
	call	TK_10		;	   10 
;	movwf	StatusRTK_10
DoneTK_10
; *******************  Begin File ADC\MLTask_ADC.inc ***************** 
 extern ADC_Task				;
	btfsc	ADC_Flag,0,ACCESS	;
		call	ADC_Task		;
