; ********** GENERATED Common Data Table File Created 16/12/2019 23:02:47.76 
; *******************  Begin File EPROM\Table_EPROM.inc **************** 
;   ,   .
;       ,
;   . 
;       - 
;      
;#ifdef	W1_Pin
;	#define ParametrCmn	d'16';      
;#else
;	#define ParametrCmn	d'14';      1-W
;#endif
;;     
;#define ParamBlockNum d'16';    
;#define ParamBlockLen d'13';    
;;     :
; dw	PCPWM_MotorNum	;  
;    Parameters_PSW_12b.xls/Param
;    EPROM\EPROM_RegsAdr.inc
;  PCPWM_3F\Parameters_PSW_12b.xls
	global	EPROM_Table_End,EPROM_Table;
EPROM_Table
  dw PCPWM_MotorNum; 1=  0-15
  dw LCD_DebounceTimeOut; 2= 
  dw LCD_6_4; 3= 4 
  dw Adc_Corr+3; 4=  
  dw Adc_Corr+2; 5= 
  dw Adc_Corr+1; 6=  
  dw Adc_Corr+0; 7= 
  dw Par_UV; 8=  (  )
  dw Par_V; 9= 
  dw Par_VS; 10=  
  dw Par_T; 11=  
	#ifdef	W1_Pin
  dw Par_K; 12=W1 Temp
  dw Par_K1; 13=W1 temp1
	#endif
  dw PcDC_VN; 14=  DC 
  dw PcPwmTopDT	;,F,BANKED; 15 =        
  dw DtConBuf; 16=DTCON 0-63  
  dw DelayCuriosityIndex; 17=Delay Curiosity
;    
; 
;     
  dw PCPWM_Speed; 1= 
  dw PCPWM_Amp; 2=V/F Amp
  dw PCPWM_VFStart; 3=V/F Start
  dw PCPWM_Accelerate; 4=Accelerate
  dw Par_A; 5=
  dw PCPWM_MaxSpdIndx; 6=  
  dw PcPwmFrqInd; 7=  0-20
  dw PcPwmAngInd; 8=   0-3
  dw PCPWM_AutoStart; 9=  -127:127
  dw PcPwmProg; 10=   
  dw PcDC_Kf; 11= DC 
  dw PCPWM_Speed_M0; 12=   1
  dw PCPWM_Speed_M1; 13=   2
EPROM_Table_End
;
; *******************  Begin File LCD_Key_Enc\Table_LCD_Key_Enc.inc **************** 
;*********    -    .
 #include Proj_Dir\LCD_Key_Enc\LCD_Text_FA.inc	;    .

 #include Proj_Dir\LCD_Key_Enc\LCD_Text_0-5.inc	;      

 #include Proj_Dir\LCD_Key_Enc\LCD_Enc_Text.inc	;      
;**********    ; *******************  Begin File 1W\Table_1W.inc **************** 
;*************************Table_1W.h Begin **********************
	global	Table_1W

Table_1W	;   1-wire 
		db	d'0',d'3'	;     
#ifdef PCPWM_Board ;       
		db	0x28,0x47,0x51,0xEE,0x09,0x00,0x00,0x64	;   1
		db	0x28,0x59,0x20,0xED,0x09,0x00,0x00,0x04	;   2
		db	0x28,0x5B,0x76,0x39,0x01,0x00,0x00,0x49	;   0724C3-422AE    
#else ;       - , , 
		db	0x28,0x47,0x51,0xEE,0x09,0x00,0x00,0x64	;   1
		db	0x28,0x59,0x20,0xED,0x09,0x00,0x00,0x04	;   2
		db	0x28,0x4C,0x70,0x39,0x01,0x00,0x00,0x0B	;   0724C3-422AE    
#endif
;**** End

; *******************  Begin File PCPWM_3F\Table_PCPWM_3F.inc **************** 
;************ PCPWM_Table **********************
	global	TabPwmFreq
TabPwmFreq	;        - 21 
  #include Proj_Dir\PCPWM_3F\PwmTab.inc	; 21   ~ 12  = 252 

	global	TabDeltAngle	;    
TabDeltAngle;     - 4  (45/72/90/120 )
  #include Proj_Dir\PCPWM_3F\AngTab.inc	; 4   3  = 12 

	global	Table_Sinus,Tab_SinEnd		;
Table_Sinus	;   816    1112  
 #ifdef	PCPWM_12b ; 12    8  -   
;	 ~2      -   
; .
;		Table_Sinus       code   0x0001f2    program   0x001b84
;       Table_Sinus       code   0x0001f2    program   0x001392
	errorlevel  -311 ; 		Message[311] 
#ifdef	PCPWM_CoSinus; Yes	;  ~2        ~10 
  	#include Proj_Dir\PCPWM_3F\CoSinTab_dW12.inc;       
#else	;   -   ,    8  RC  CLC/512 .
	#include Proj_Dir\PCPWM_3F\SinTab_dW12.inc	;   -  .
#endif
 	errorlevel  +311 ; 	Message[311] 
 #else	;  8 
; 256   2  -.
  #include Proj_Dir\PCPWM_3F\SinusTable_dw_16.inc	;   -  .
 #endif ;#ifdef	PCPWM_12b ; 12    8  -   
Tab_SinEnd	;    

;      24 :
	errorlevel  -311 ; 		Message[311] 
;Message[311] C:\MICROCHIP\_PRG\RTOS_3F_4431\PCPWM_3F\SPEEDTABLE_DB.INC 65 :
; Operand of HIGH operator was larger than H'FFFF'.
	global	Table_Simples
Table_Simples	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S2.inc	; 

	global	Simples_100
Simples_100	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S_100.inc	; 

	global	Simples_200
Simples_200	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S_200.inc	; 

	global	Simples_400
Simples_400	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S_400.inc	; 

	global	Simples_800
Simples_800	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S_800.inc	; 
 	errorlevel  +311 ; 	Message[311] 

;************ PCPWM_Table end**********************
